﻿#targetengine 'scriptPalette'
try{//если функция еще не загружена в targetengine - загружаем
delete scriptPalette_AlexDenScripts;//для отладки
scriptPalette_AlexDenScripts;
}catch(err){
scriptPalette_AlexDenScripts = function(){
/* ======= ! ! ! =========*/
// If you create sets are not stored, into this variable can enter the path to the service directory of script
// Если создаваемые наборы не сохраняются - в эту переменную можно вписать путь к служебной папке скрипта.

var USER_FOLDER = "";

/* Example, пример: var USER_FOLDER = "D:/Works/Scripts/scriptPalette";
/* ======= ! ! ! =========*/
//=============================================
var help = "To create and edit sets of buttons, use the context menu that is called by right-clicking.\r\r";
help += "If you create sets are not saved, open the script and change the line 'var USER_FOLDER = \"\";'.\r";
help += "For example:  'var USER_FOLDER = \"D:/Works/Scripts/scriptPalette\";'.\r\r";
/*help += "For CS5:\r";
help += "Not recommended to run this script through the plug-in 'Script Bay'.\r\r";*/
help += "\r";
help += "Для создания и редактирования наборов кнопок используйте контекстное меню, которое вызывается щелчком правой кнопки мыши.\r\r";
help += "Если создаваемые наборы не сохраняются, откройте скрипт и измените строку 'var USER_FOLDER = \"\";'.\r"
help += "Например:  'var USER_FOLDER = \"D:/Works/Scripts/scriptPalette\";'.\r\r";
/*help += "Для CS5:\r";
help += "Не рекомендуется запускать этот скрипт через плагин 'Script Bay'.\r";*/
//=============================================
var script = getScriptLibrary( {name: 'scriptPalette', version: 2.44, release: 2009, supportApp: [ 'InDesign6', 'Illustrator14', 'InDesign7', 'Illustrator15' ], prefsInit: true, targetengine: true} );
if(!script.systemCheck())
	return;
extension_scriptInfo( script );
extension_contextMenu( script );
//script.language = 'en';
var OPTIONS = script.checkVersion( getDefaultOptions(), script.userPrefs('OPTIONS') );

var win = false;
var thisCS = script.appVersionCS();
var closeApp = false;
var fsTypes = ['file  ','folder  '];
var currentGroupIndex = null;
var saveSetsStatus = false;
var runAIMetods = {
	 "Execute file": { metod: function( fsObject ){ fsObject.execute() }, supportCS: 0, note: "Attention!\n To use this method, put the top line of the script:\n #target 'illustrator'" },
	 "BridgeTalk": { metod: function( fsObject ){ var jsSource = script.fileRead( fsObject ); if( !jsSource ) return; var bt = new BridgeTalk; bt.target = 'illustrator'; bt.body = jsSource; bt.send(); }, supportCS: 3 },
	 "executeScript": { metod: function( fsObject ){ var jsSource = script.fileRead( fsObject ); if( !jsSource ) return; illustrator.executeScript( jsSource ) }, supportCS: 4 },
	 "evalFile": { metod: function( fsObject ){ evalScript_AlexDenScripts( fsObject ) }, supportCS: 3 },
	}

//================ START ===============================
addScriptImages();
createPalette();
palette_ContextMenu();
loadSets();
activateOptions();
win.show();
//=====================================================
function saveProperties(){
	// сохраняем настройки
	script.userPrefs('OPTIONS', getOptions() );
	// СОХРАНЯЕМ НАСТРОЙКИ
	script.saveScriptPrefs();
	}
function getDefaultOptions(){
	return {
		showOptionsButton:true,
		location:[100,100], 
		orientation:'column', 
		currentGroup:0, 
		relativeLinks:true, 
		autoSave:true, 
		changeMetodIllustrator:"BridgeTalk",
		activeMethods:{
			"Execute file": true,
			 "BridgeTalk":true,
			 "executeScript": false,
			 "evalFile": false
			}
		};
	}
function getOptions(){
	try{
	for(var i = 0; i < win.Grps.children.length; i++)
		if(win.Grps.children[i].visible)
			break;
	OPTIONS.location = [win.location[0],win.location[1]];
	OPTIONS.orientation = win.orientation;
	OPTIONS.currentGroup = i;
//	return false;
	return OPTIONS;
	}catch(err){ script.alertError(err); return false; }
	}
function activateOptions(){
	try{
	win.location = OPTIONS.location;
	paletteOrientation( OPTIONS.orientation );
	if(win.Bts.children.length > OPTIONS.currentGroup)
		win.Bts.children[OPTIONS.currentGroup].onClick();
	else if(win.Bts.children.length > 0)
		win.Bts.children[0].onClick();
	return true;
	}catch(err){
//		activateOptions( getDefaultOptions() );
		script.alertError(err); return false;
		}
	}
//=====================================================
function addScriptImages(){
	var code = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x10\b\x06\x00\x00\x00\x1F\u00F3\u00FFa\x00\x00\x00\x04gAMA\x00\x00\u00AF\u00C87\x05\u008A\u00E9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x021IDATx\u00DA\u00A4S\u00B9\u008A\"Q\x14\u00BD\u00E5\u00D6\"*\u00EE\x18\u00B84\u0088\n\"4\u0082\u008A\u00A0\u00A0\r\u0086\u00E6\u00FE\u0080\u0098\x1A\x1A\u00AA\u00FF`b\u00D8\u00A1\u0099\u0081\u00A1\u00E0\f\n\u00AD(Hc\u00E6\u009A(\u0088\u00BB\u0091\u00B8O\u009D\u0087\u00CA\f3\x1D\u00CD\u0083[u\u00EA\u00DEs^\u00DDz\u00E7\x16W(\x14\u00E8\u009B\u0095\u00E5#s\u00C7\u00B9\u00FB\u00F3_Kp\u00BD^)\x1A\u008D\x12\x7F\u00CF\u00F2Q\x05\u00BE?g\u00BE\u00C1Up\u00EF\u0098\u00B8|>\u00FF|\u009B\u00CF\u00E7\u00A3\u00E1pH\x1A\u008D\u0086\u00D4j5i\u00B5Z\u00BA\u00DDn\u00B4^\u00AFi\u00B3\u00D9\u00B0\u00BB\u00CDf\u00A3V\u00AB\u00F5\u00ECJt\u00B9\\\u00F0\x10\u00F6z\u00BD\u00A4\u00D3\u00E9H\u00A9T2\u00E2b\u00B1`\x18\x0B\x18\x1BZ\u00ADV\u0092H$\u00E4\u00F1x\u00A8\u00DDn\u0087\u00D9'`\u0083X,\u00F6\u00DE\u00EF\u00F7i\u00BF\u00DF\u0093@ `d\u00BB\u00DDNb\u00B1\u0098\x050r\u00A8\u0081\x03.4\u00D0\u008A\u00CE\u00E73{\u008BB\u00A1\u00A0\u00F9|Nz\u00BD\u009E^^^\u00A8\u00D1hP\u00BD^g\u00B5P(D\u0081@\u0080\x0E\u0087\x03\u00EB\x06\\,h\x05\u00FC%[,\x16oH\u00A2(\x14\n\u00D1\x1E\u00E2G:\u009D\u00E6\x10\u00C0\u00C8\u00A1\u00F6\u00D8\x00\x1Ah\u00B1A&\x1E\u008F\u0093\u00D1h$\u00B3\u00D9L\"\u0091\u0088\u00BA\u00DD.\u00A5R\u00A9\u00F7\u0087U\u00C0\u00C8\u00A1\x06\x0E\u00B8\u00D0@+:\u009DN4\u0099L\u00FE\u00F0\u00F6\u00D1\u00E2\u00BFr\u00E0\u00C3\x11\x04\u00B00\x18\fr\u0083\u00C1 \u0082\x13\u009FN\u00A7d0\x18H.\u0097\u00D3\u00E7\u00E7g\u00C4\u00E1p|@T.\u0097\u00ABn\u00B7\u00FBU*\u0095\u00B2\u00EEpx\u00B5Z\rs\u0090cg\u0090H$\u00B8\u00E5r\u00C9\u0084\u00BB\u00DD\u008E\u00D9\u00E5r\u00B9\"\u0095J\u00E5\u0086\x00F\x0E5p\u00C0\u0085\x06\u00DA\u00A7\x0B8\x1C\u0093\u00C9\u00C4\x1C\u0098\u00CDf\u00CC6L\x1B\x16\u00DAEN&\u0093\u00B1\r`\u00E3\u00C3\x05\u00A1\u00DF\u00EF\u00A7f\u00B3Yu:\u009D\u00AF\x18\u00A6\u00D1h\u00C4\u00C8\u00BD^\u008F\u008E\u00C7#\u00B3\u00F6\u00EB\u00EB\u008BY\u0088\u00D6\u00F9O\u00A1\u00EDvK\u00A5R)\u00C2O\u00E9\u00C7c\x12\x7F\u00F26E\u0080\u00C7\u00E31{\u00BBJ\u00A5\u00A2\u00DFgd\u00B5Z\x11\x7FV\u00AC\u00FDN\u00A7\u00C34\u00CFI\f\u0087\u00C3Y\u00FE\u009E\u0083\u00DFooo\u009C\u00C5b\u0081\u00F7\u00ECgA\x00#\u0087\x1A8\u00E0\u00DE5\u00C4%\u0093\u00C9\u00FF\u00FA\u009D\x7F\t0\x00I\\i\u00A5H\x00\u00EA^\x00\x00\x00\x00IEND\u00AEB`\u0082";
	script.writeImage(code, 'settings');
	}
//=====================================================
function getAdaptFsName(fsObject, relative){
	if(relative)
		var link = script.adaptFsNameForSave(fsObject.fsName.replace(script.file.parent.fsName, '.'));
	else
		var link = script.adaptFsNameForSave(fsObject.fsName);
	if(fsObject instanceof Folder)
		link += '/';
	return link;
	}
function getFsObject(adaptFsName){//return File or Folder
	if(adaptFsName.charAt(0) == '.')
		adaptFsName = script.file.parent.fsName + adaptFsName.substr(1);
	if(File.fs == 'Macintosh' && !(/^[.\/]/.test(adaptFsName)))
		adaptFsName = '/' + adaptFsName;
	var obj = (adaptFsName.substr(-1) == '/') ? Folder(adaptFsName) : File(adaptFsName);
	return obj;
	}
function launchFsObject(path, thisButton){
	try{
	var fsObject = getFsObject(path);
	if(!fsObject.exists){
		alert(fsObject.constructor.name + ' not found!');
//		alert('Error:\r' + fsObject.fsName + '\ris not found!');
//		thisButton.enabled = false;
		return;
		}
	if(fsObject instanceof Folder)
		return fsObject.execute();
	var type = 0;
	var extension = path.substr(path.lastIndexOf('.')+1).toLowerCase();
	if(script.appName == 'Illustrator'){
		switch( extension ){
			case 'js':
			case 'jsx':
			case 'jsxbin':
			var metod = false;
			var names = [];
			for( var m in runAIMetods )
				if( OPTIONS.activeMethods[m] && thisCS >= runAIMetods[m].supportCS )
					names.push( m );
			if( !names.length ) {
				alert( 'No selected methods for .js/.jsx' );
				return;
				}
			else if( names.length == 1 )
				return runAIMetods[names[0]].metod( fsObject );
				
			var win = new Window('dialog');
			win.margins =win.spacing =  5;
			with(win){
				win.sText = add('statictext', undefined, 'Choose method of running a script');
				win.Grp = add('group');
				win.Grp.orientation = 'row';
				with(win.Grp){
					for( var i = 0; i < names.length; i++ ){
						win.Grp[names[i]] = add("button", undefined, names[i]);
						if( runAIMetods[names[i]].note ) win.Grp[names[i]].helpTip = runAIMetods[names[i]].note;
						win.Grp[names[i]].onClick = function(){ metod = OPTIONS.changeMetodIllustrator = this.text; this.window.close(); }
						}
					}
				};
			win.defaultElement =  win.Grp[OPTIONS.changeMetodIllustrator]? win.Grp[OPTIONS.changeMetodIllustrator] : win.Grp.children[0];
				
			var shift = ($.screens[0].right - thisButton.window.location[0]) < (100*win.Grp.children.length) ? -100*win.Grp.children.length : 0;
			win.location = [thisButton.window.location[0]+thisButton.windowBounds[0]+(thisButton.size[0]/2)+shift, thisButton.window.location[1]+thisButton.windowBounds[1]+(thisButton.size[1]/2)];
			win.show();
			
			if( metod )
				runAIMetods[metod].metod( fsObject );
			break;
			default:
			fsObject.execute();
			}
		return;
		}
	//InDesign
	switch( extension ){
		case 'js':
		case 'jsx':
		case 'jsxbin':
		type = 1246973031;//ScriptLanguage.javascript
		break;
		case 'vbs':
		type = 1447185511;//ScriptLanguage.VISUAL_BASIC
		break;
		case 'applescript':
		type = 1095978087;//ScriptLanguage.APPLESCRIPT_LANGUAGE
		}
	if(!type)
		return fsObject.execute();
	app.doScript(fsObject, type);
	}catch(err){script.alertError(err)};
	}

//================ PALETTE ===============================
function createPalette(){
	try{
	var item;
	win = new Window('palette', script.name);
	win.preferredSize = [20,20];
	win.margins = 3;
	win.spacing = 5;
	with(win){
		win.Bts = add('group');
		win.Bts.orientation = 'row';
		win.Bts.margins = 0;
		win.Bts.spacing = 5;
		
		win.Grps = add('group');
		win.Grps.orientation = 'stack';
		win.Grps.margins = 0;
		win.Grps.spacing = 0;
		}
	if( OPTIONS.showOptionsButton )
		addOptionsButton( win );
	win.onClose = function(){
		saveProperties();
		closeApp = true;
		saveSets();
		}
	}catch(err){script.alertError(err)};
	}
function addOptionsButton( win ){
	if( win.Settings )
		return;
	win.Settings = win.add('iconbutton', undefined, undefined, {style: 'toolbutton'});
	win.Settings.preferredSize = [22,22];
	win.Settings.image = script.images.settings;
	win.Settings.onClick = getSettings;
	win.layout.layout(true);
	}
function removeOptionsButton( win ){
	if( !win.Settings )
		return;
	win.remove( win.Settings );
	win.Settings = false;
	win.layout.layout(true);
	}

function palette_ContextMenu(){
	script.messages.ru["New name"] = 'Новое имя';
	
	script.messages.ru["Add group"] = 'Добавить группу';
	script.messages.ru["Delete group"] = 'Удалить группу';
	script.messages.ru["Rename group"] = 'Имя группы';
	
	script.messages.ru["Add file"] = 'Добавить файл';
	script.messages.ru["Add folder"] = 'Добавить папку';
	script.messages.ru["Rename"] = 'Переименовать';
	script.messages.ru["Relink"] = 'Сменить связь';
	script.messages.ru["Delete"] = 'Удалить';
	
	script.messages.ru["Cut"] = 'Вырезать';
	script.messages.ru["Copy"] = 'Копировать';
	script.messages.ru["Paste"] = 'Вставить';
	
	script.messages.ru["Cut all"] = 'Вырезать все';
	script.messages.ru["Copy all"] = 'Копировать все';
	
	script.messages.ru["Move Up"] = 'Двигать вверх';
	script.messages.ru["Move Down"] = 'Двигать вниз';
	
	script.messages.ru["Options"] = 'Настройки';
	
	var contextMenuItems = [
			{ name: script.localize("Add file"), action: function(EVENT){addFsObject_Menu(EVENT)}, activation: addButtonAccess, notCloseMenu: false },
			{ name: script.localize("Add folder"), action: function(EVENT){addFsObject_Menu(EVENT, true)}, activation: addButtonAccess, notCloseMenu: false },
			{}, //empty separator
			{ name: script.localize("Rename"), action: renameButton, activation: isButton, notCloseMenu: false },
			{ name: script.localize("Relink"), action: relinkButton, activation: isButton, notCloseMenu: false },
			{ name: script.localize("Delete"), action: delButton, activation: isButton, notCloseMenu: false },
			{}, //empty separator
			{ name: script.localize("Copy"), action: copyButton, activation: isButton, notCloseMenu: false },
			{ name: script.localize("Cut"), action: cutButton, activation: isButton, notCloseMenu: false },
			{ name: script.localize("Paste"), action: paste, activation: function(EVENT){return win.BUFFER && addButtonAccess(EVENT) ? true : false}, notCloseMenu: false },
			{}, //empty separator
			{ name: script.localize("Copy all"), action: copyAllButtons, activation: isButton, notCloseMenu: false },
			{ name: script.localize("Cut all"), action: cutAllButtons, activation: isButton, notCloseMenu: false },
			{}, //empty separator
			{ name: script.localize("Move Up"), action: function(EVENT){swapOfButtons(EVENT, -1)}, activation: isButton, notCloseMenu: true },
			{ name: script.localize("Move Down"), action: function(EVENT){swapOfButtons(EVENT, 1)}, activation: isButton, notCloseMenu: true },
			script.separatorMenuItem, // separator with line
			{ name: script.localize("Add group"), action: function(){addGroup(true)}, activation: true, notCloseMenu: false },
			{ name: script.localize("Delete group"), action: deleteGroup, activation: addButtonAccess, notCloseMenu: false },
			{ name: script.localize("Rename group"), action: renameGroup, activation: addButtonAccess, notCloseMenu: false },
			{}, //empty separator
			{ name: script.localize("Options"), action: getSettings, activation: true, notCloseMenu: false },
			];
//	script.addContextMenu( win, contextMenuItems, true );
	script.addContextMenu( { target: win, menuItems: contextMenuItems, palette: true, preAction: preAction } );
	function preAction( EVENT, optionsObject ){
		if( EVENT.target.type == 'button' ){
			var fsObject = getFsObject(EVENT.target.helpTip);
			optionsObject.title = fsObject.constructor.name + " status: " + (fsObject.exists ? "" : "not ") + "exists";
			}
		else if( EVENT.target.type == 'iconbutton' && EVENT.target.properties && EVENT.target.properties.name == 'ICON' )
			selectGroup( script.getUiObjectIndex(EVENT.target) );
		return true ;
		}
//	function isIcon( EVENT ){ return EVENT.view.type == 'iconbutton' && EVENT.view.properties && EVENT.view.properties.name == 'ICON' ? true : false }
	function isButton( EVENT ){ return EVENT.target.type == 'button' ? true : false }
	function isGroupOfButtons( EVENT ){ return EVENT.target.type == 'group' && EVENT.target.properties && EVENT.target.properties.name == 'BUTTONS'  ? true : false }
	function isButtonOrGroupOfButtons( EVENT ){ return isButton( EVENT ) || isGroupOfButtons( EVENT ) ? true : false }
	function addButtonAccess( EVENT ){ return getCurrentGroupIndex() != null }
	function selectAll( EVENT ){ return getCurrentGroupIndex() != null }
	
	function renameButton( EVENT ){
		var BUTTON =  EVENT.view;
		var name = prompt( script.localize('New name')+':', BUTTON.text, script.name );
		if( name ){
			BUTTON.text = name;
			saveSetsStatus = true;
			}
		}
	function relinkButton( EVENT ){
		var BUTTON =  EVENT.target;
		var thisFsObject = getFsObject(BUTTON.helpTip);
		var myF = (thisFsObject.constructor != Folder) ? File.openDialog("Add file") : Folder.selectDialog( "Add folder", thisFsObject );
		if(!myF)
			return;
		BUTTON.helpTip = getAdaptFsName(myF, OPTIONS.relativeLinks);
		saveSetsStatus = true;
		}
	function swapOfButtons(EVENT, next){
		try{
		var BUTTON = EVENT.target;
		var buttonIndex = script.getUiObjectIndex(BUTTON);
		if( (buttonIndex+next) < 0 || (buttonIndex+next) == BUTTON.parent.children.length )
			return;
		var NEXT_BUTTON = BUTTON.parent.children[buttonIndex + next];
		//set data
		var name = BUTTON.text;
		var link = BUTTON.helpTip;
		//swap
		BUTTON.text = NEXT_BUTTON.text;
		BUTTON.helpTip = NEXT_BUTTON.helpTip;
		NEXT_BUTTON.text = name;
		NEXT_BUTTON.helpTip = link;
		
		EVENT.target = EVENT.view = NEXT_BUTTON;
		saveSetsStatus = true;
		}catch(err){script.alertError(err)};
		}
	function addFsObject_Menu(EVENT, folder){
		try{
		var thisFsObject = undefined;
		if(EVENT.view.type == 'button'){
			thisFsObject = getFsObject(EVENT.view.helpTip);
			}
		var myF = (!folder) ? File.openDialog("Add file") : Folder.selectDialog( "Add folder", thisFsObject );
		if(!myF)
			return;
		var name = script.getDisplayName(myF).substr(0, 10);
		addButton(getCurrentGroup(), name, getAdaptFsName(myF, OPTIONS.relativeLinks));
		saveSetsStatus = true;
		}catch(err){script.alertError(err)};
		}
	function delButton( EVENT ){
		try{
		EVENT.view.parent.remove(EVENT.view);
		win.layout.layout(true);
		saveSetsStatus = true;
		}catch(err){script.alertError(err)};
		}
	//================ CUT / COPY / PASTE ==========================
	function copyButton( EVENT ){
		win.BUFFER = getGroupItemData( EVENT.view );
		}
	function cutButton( EVENT ){
		copyButton( EVENT );
		delButton( EVENT );
		}
	function paste( EVENT ){
		if( !win.BUFFER )
			return;
		var group = getCurrentGroup();
		if( win.BUFFER.constructor == Array )
			for( var i = 0; i < win.BUFFER.length; i++ )
				addButton(group, win.BUFFER[i].name, win.BUFFER[i].adaptFsName);
		else
			addButton(group, win.BUFFER.name, win.BUFFER.adaptFsName);
		}
	
	function copyAllButtons( EVENT ){
		var buttons = getCurrentGroup().children;
		win.BUFFER = [];
		for( var i = 0; i < buttons.length; i++ )
			win.BUFFER[i] = getGroupItemData( buttons[i] );
		}
	function cutAllButtons( EVENT ){
		try{
		copyAllButtons( EVENT );
		var group = getCurrentGroup();
		for( var i = group.children.length-1; i > -1; i-- )
			group.remove(group.children[i]);
		win.layout.layout(true);
		saveSetsStatus = true;
		}catch(err){script.alertError(err)};
		}
	// ==============  GROUP =====================================
	function getCurrentGroup(){
		return win.Grps.children[getCurrentGroupIndex()];
		}
	function getCurrentGroupIndex(){
		for( var i = 0; i < win.Bts.children.length; i++ )
			if( !win.Bts.children[i].enabled )
				return i;
		return null;
		}
	function deleteGroup( EVENT ){
		try{
		var INDEX = getCurrentGroupIndex();
		if(win.Grps.children[INDEX].children.length){
			var very = confirm('This group contains buttons. Delete the group?');
			if(!very)
				return;
			}
		win.Bts.remove(win.Bts.children[INDEX]);
		win.Grps.remove(win.Grps.children[INDEX]);
		win.layout.layout(true);
		selectGroup( (INDEX) ? INDEX-1 : 0 );
		saveSetsStatus = true;
		}catch(err){script.alertError(err)};
		}
	function renameGroup( EVENT ){
		try{
		var BUTTON = win.Bts.children[ getCurrentGroupIndex()];
		var name = prompt( script.localize('New name')+':', BUTTON.title, script.name );
		if( name ){
			BUTTON.title = name;
			saveSetsStatus = true;
			}
		}catch(err){script.alertError(err)};
		}
	}
//================ SETTINGS ===============================
function getSettings(){
	try{
	var winSettings = new Window("dialog", 'Options', );
	winSettings.preferredSize = [200,50];
	winSettings.alignChildren = ['left', 'top'];
	winSettings.margins = 5;
	winSettings.spacing = 10;
	with(winSettings){
		winSettings.Orientation = add( "group", undefined, undefined );
		with(winSettings.Orientation){
			winSettings.Orientation.column = add( "radiobutton", undefined, 'column' );
			winSettings.Orientation.row = add( "radiobutton", undefined, 'row' );
			}
		winSettings.showOptionsButton = add( "group" );
		winSettings.showOptionsButton.orientation = "row";
		with(winSettings.showOptionsButton){
			winSettings.showOptionsButton.Value = add( "checkbox", undefined, "show button '"+script.localize('Options')+"'" );
			add( "image", undefined, script.images.settings );
			}
		winSettings.autoStart = add( "checkbox", undefined, 'autoStart' );
		winSettings.autoSave = add( "checkbox", undefined, 'autoSave' );
		winSettings.relativeLinks = add( "checkbox", undefined, 'use relative links' );
		
		winSettings.AI_Metods = add( "panel", undefined, undefined );
		winSettings.AI_Metods.sText = winSettings.AI_Metods.add( "statictext", undefined, 'Methods of running of scripts for AI (.js/.jsx)' );
		winSettings.AI_Metods.orientation = 'column';
		winSettings.AI_Metods.alignChildren = ['left', 'top'];
		
		winSettings.buts = add( "group", undefined, undefined );
		winSettings.buts.alignment = ['right', 'top'];
		with(winSettings.buts){
			winSettings.buts.info = add( "button", undefined, 'Info' );
			winSettings.buts.Close = add( "button", undefined, 'Close' );
			}
		}
	
	var isAI = script.getAppName( 'illustrator' );
	winSettings.AI_Metods.sText.enabled = isAI;
	for( var m in runAIMetods ){
		winSettings.AI_Metods[m] = winSettings.AI_Metods.add("checkbox", undefined, m);
		if( !isAI || runAIMetods[m].supportCS > thisCS )
			winSettings.AI_Metods[m].enabled = false;
		else{
			winSettings.AI_Metods[m].value = OPTIONS.activeMethods[m];
			winSettings.AI_Metods[m].onClick = function(){ OPTIONS.activeMethods[this.text] = this.value }
			if( runAIMetods[m].note )
				winSettings.AI_Metods[m].helpTip = runAIMetods[m].note;
			}
		}

	if(script.file.parent.fsName == script.getStartupFolder().fsName){
		winSettings.autoStart.value = true;
		winSettings.autoStart.enabled = false;
		}
	else if( script.appName != 'Illustrator' )
		winSettings.autoStart.value = script.getFileAlias(script.getStartupFolder(), script.file);
	winSettings.showOptionsButton.Value.value = OPTIONS.showOptionsButton;
	winSettings.autoSave.value = OPTIONS.autoSave;
	winSettings.relativeLinks.value = OPTIONS.relativeLinks;
	(win.orientation == 'column') ? (winSettings.Orientation.column.value = true) : (winSettings.Orientation.row.value = true);
	
	winSettings.Orientation.column.onClick = winSettings.Orientation.row.onClick = function(){
		paletteOrientation(this.text);
		}
	winSettings.showOptionsButton.Value.onClick = function(){
		if( this.value )
			addOptionsButton( win );
		else
			removeOptionsButton( win );
		OPTIONS.showOptionsButton = this.value;
		saveSetsStatus = true;
		}
	winSettings.relativeLinks.onClick = function(){
		var groups = win.Grps.children;
		for(var i = 0; i < groups.length; i++)
			for(var j = 0; j < groups[i].children.length; j++)
				 groups[i].children[j].helpTip = getAdaptFsName(getFsObject(groups[i].children[j].helpTip), this.value);
		OPTIONS.relativeLinks = this.value;
		saveSetsStatus = true;
		this.window.listBox.notify();
		}
	winSettings.autoStart.onClick = function(){
		if( script.appName == 'Illustrator' ){
			alert( 'For auto startup of the application, place script file in directory:\r'+script.getStartupFolder().fsName );
			this.value = false;
			return;
			}
		var alias = script.getFileAlias(script.getStartupFolder(), script.file, this.value);
		if(!alias)
			this.value = false;
		else if(!this.value)
			alias.remove();
		}
	winSettings.autoSave.onClick = function(){
		OPTIONS.autoSave = this.value;
		}
	winSettings.buts.info.onClick = function(){
		script.getWinInfo( '', help );
		}
	winSettings.buts.Close.onClick = function(){
		this.window.close();
		}
	winSettings.center();
	winSettings.show();
	}catch(err){script.alertError(err)};
	}

//================ SELECT GROUP ===============================
function selectGroup(groupIndex){
	try{
	for(var i = 0; i < win.Bts.children.length; i++){
		if(i==groupIndex){
			win.Bts.children[i].enabled = false;
			win.Grps.children[i].visible = true;
			continue;
			}
		win.Bts.children[i].enabled = true;
		win.Grps.children[i].visible = false;
		}
	}catch(err){script.alertError(err)};
	}
//================ ADD GROUP ===============================
function addGroup(New){
	try{
	var item = win.Bts.add('iconbutton', undefined, undefined, {name: "ICON"});
	item.preferredSize = [20,20];
	item.titleLayout.margins = [6,3,0,0];
	item.titleLayout.spacing = 0;
	item.title = "W"; // назначаем длинный символ для создания поля title, достаточного для любого одиночного символа
	item.titleLayout.characters = 1;
	item.title = ""; // сбрасываем значение
	item.onClick = function(){
		selectGroup(script.getUiObjectIndex(this));
		}
	item = win.Grps.add('group', undefined, undefined, {name: "BUTTONS"});
	item.orientation = win.orientation;
	item.spacing = 5;
	item.alignChildren = ['fill', 'top'];
	if(New){
		win.layout.layout(true);
		selectGroup(win.Bts.children.length-1);
		saveSetsStatus = true;
		}
	return item;
	}catch(err){script.alertError(err)};
	}
//================ GROUP ITEMS ===================================
function getGroupItemData( groupItem ){
	return {
		type: groupItem.type,
		name: groupItem.text,
		adaptFsName: groupItem.helpTip,
		};
	}
//================ ADD BUTTON ===============================
function addButton(group, name, adaptFsName){
	try{
	var item = group.add('button', undefined, name);
	item.helpTip = adaptFsName;
	item.onClick = function(){
		this.active = false;
		launchFsObject(this.helpTip, this);
		this.active = false;
		}
//	if(!getFsObject(item.helpTip).exists)
//		item.enabled = false;
	win.layout.layout(true);
	return item;
	}catch(err){script.alertError(err)};
	}
//================ ORIENTATION ===============================
function paletteOrientation(orientation){
	win.orientation = orientation;
//	win.Settings.preferredSize = orientation == 'column' ? [100,22] : [22,22];
	for(var i = 0; i<win.Grps.children.length; i++)
		win.Grps.children[i].orientation = orientation;
	win.layout.layout(true);
	}

//================ SETS ===============================
function getFolderSetsPath(){
	if( USER_FOLDER ){
		if( Folder(USER_FOLDER).exists )
			return USER_FOLDER;
		else{
			if( !this.Flag )
				alert( script.localize("Folder not found")+': ' + USER_FOLDER);
			this.Flag = true;
			}
		}
	return script.file.parent.fsName;
	}
function getFileSets(){
	return File( getFolderSetsPath() + '/' + script.name + '_sets.txt');
	}
function loadSets(){
	var file = getFileSets();
	if(!file.exists){
		addGroup();
		return;
		}
	var SET = script.prefRead( file );
	if( !SET ){
		addGroup();
		return;
		}
	activateSets( SET );
	}
function saveSets(){
	if(!saveSetsStatus)
		return;
	if( !OPTIONS.autoSave && !confirm('Save changes?') )
		return;
	script.prefSave( getSets(), getFileSets() );
	}
function getDefaultSets(){
	return {
		0: {}
		};
	}
function getSets(){
	try{
	var SET = {};
	var group;
	for(var i = 0; i < win.Grps.children.length; i++ ){
		SET[i] = {
			title: win.Bts.children[i].title,
			buttons: [],
			};
		group = win.Grps.children[i];
		for(var z = 0; z < group.children.length; z++)
			SET[i].buttons[z] = getGroupItemData( group.children[z] );
		}
//	alert( SET.toSource() );
	return SET;
	}catch(err){ script.alertError(err); return getDefaultSets(); }
	}
function activateSets( SET ){
//	alert( SET.toSource() );
	try{
	for( var i in SET ){
		var group = addGroup();
		win.Bts.children[i].title = SET[i].title ? SET[i].title : '';
		if( SET[i].buttons && SET[i].buttons.length )
			for(var z = 0; z < SET[i].buttons.length; z++)
				if( SET[i].buttons[z].name && SET[i].buttons[z].adaptFsName )
					addButton( group, SET[i].buttons[z].name, SET[i].buttons[z].adaptFsName );
		}
	return true;
	}catch(err){
		script.alertError(err); return false;
		}
	}


evalScript_AlexDenScripts = function( file ){
	$.evalFile( file );
	}
function getScriptLibrary( scriptArgs ){
//	scriptArgs = {
//		name: '', 
//		version: Number, 
//		autor: '', 
//		mail: '', 
//		sites: [ '','' ](URLs), 
//		release: Number (year), 
//		supportApp: [ 'InDesign5', 'Photoshop10', 'Illustrator13', 'InDesign6', 'Photoshop11', 'Illustrator14' ], 
//		supportFS: [ 'Windows', 'Macintosh' ] ,
//		prefsInit: Boolean,
//		consol: Boolean, init output messages to consol
//		log: Boolean, init output messages to log-file
//		logWithoutStart: Boolean\
//		workingDirectory: Folder (Optional)
//		targetengine: Bool (Default - false)
//		}
	if( !scriptArgs ) scriptArgs = {};
	var lib = getLib();
	lib.name = scriptArgs.name || lib.getNameOnly( lib.file );
	if( lib.targetengine && lib.getAppName('photoshop') )
		lib.targetengine = false;
	// log
	lib.logInit = scriptArgs.log;
	lib.logWithoutStart = scriptArgs.logWithoutStart;
	lib.LOG();
	// prefs init
	lib.workingDirectory = scriptArgs.workingDirectory;
	if( scriptArgs.prefsInit )
		lib.prefs_Init();
	// consol init
	if( scriptArgs.consol ){
		var mess = new Window('dialog');
		mess.add('statictext', undefined, 'CONSOL' );
		mess.addEventListener('focus', function(e){$.sleep(300);mess.close();});
		mess.center();
		mess.show();
		lib.consolInit = true;
		lib.consol( '========\r========' );
		}
	return lib;
	function getLib(){
		var scriptLIB;
		scriptLIB = {
		libraryVersion: 1.7, // версия библиотеки script
		extensions: {},//объект для регистрации подгруженных расширений
		version: scriptArgs.version || 1,
		autor: scriptArgs.autor || 'Alexey Dmitrienko',
		mail: scriptArgs.mail || 'alexey-dmitrienko@ya.ru',
		sites: scriptArgs.sites || [
			'www.scriptuibuilder.com',
			'www.sites.google.com/site/scriptuibuilder/'
			],
		release: scriptArgs.release || new Date().getFullYear(),
		supportApp: scriptArgs.supportApp || [ // пустой массив - поддержка без ограничений
			// 'InDesign5', 'Photoshop10', 'Illustrator13', 
			],
		supportFS: scriptArgs.supportFS || [ // пустой массив - поддержка без ограничений
			// 'Windows', 'Macintosh' 
			],
		targetengine: scriptArgs.targetengine,
		//============= Consol =============================
		consolInit: false, // вывод в консоль отключен
		consol: function(){ // arguments
			if( !this.consolInit || !arguments.length )
				return;
			var str = '';
			for( var i = 0; i < arguments.length; i++ ){
				if( arguments[i] == undefined || arguments[i] == null )
					str += ' ' + arguments[i];
				else
					switch( arguments[i].constructor ){
						case String:
						case Boolean:
						case Number:
						str += ' ' + arguments[i];
						break;
						default:
						str += ' ' + arguments[i].toSource();
						}
				}
			$.writeln( str );
			},
		//============= Log ==============================
		logInit: false, // вывод в log-файл отключен
		logFiles: [],
		addLogFile: function( file ){
			if( file && file instanceof File )
				this.logFiles.push( file );
			},
		logSTRING: '',
		LOG: function( str, write ){ // write = true
			try{
			if( !this.logInit )
				return;
			if( !this.logStarted ){
				this.FILE = new File( this.file.parent.absoluteURI + '/log.txt' );
				this.logStarted = new Date();
				if( !this.logWithoutStart )
					this.logSTRING = '(' + (this.logStarted.toLocaleTimeString())+', '+this.logStarted.toLocaleDateString()+'): ' + "Start log for "+this.fullName() + " (" + this.getDisplayName(this.file) +")";
				}
			if( str )
				this.logSTRING += (this.logSTRING?'\n':'')+'(' + this.logStarted.toLocaleTimeString()+'): ' + str;
			if( write && this.logSTRING ){
				this.fileWriteLine( this.FILE, this.logSTRING );
				if( this.logFiles.length )
					for( var i = 0; i < this.logFiles.length; i++ )
						this.fileWriteLine( this.logFiles[i], this.logSTRING );
				this.logSTRING = "";
				}
			}catch(err){
				if( !this.logWriteError ){
					this.logWriteError = true;
					this.alertError(err);
					}
				};
			},
		logWriteError: false,
		//============= Script =============================
		file: function(){ try{ var res = app.activeScript || new File($.fileName); if( !res || res.constructor != File ) throw "error" else return res }catch(err){ return new File(err.fileName) } }(),
		fullName: function(){return this.name+' v.'+this.version},
		notShowErrorOnThisSession: false,
		alertError: function( errorObject, message ){
			try{
			var Str = errorObject+'\r';
			Str+='string: '+errorObject.line+'\r';
			if( message )
				Str+= 'Custom message: ' + message;
			this.LOG( Str );
			this.consol( Str );
			// window
			if( this.notShowErrorOnThisSession )
				return;
			Str+= '\r'+this.fullName();
			var LIB = this;
			var win = new Window("dialog", this.localize('Error'), undefined, );
			win.margins = 5;
			with(win){
				if( Str.split(/\r/).length > 20 ){
					win.eText = add( "edittext", undefined, Str, {multiline: 'true', } );
					win.eText.preferredSize = [400,150];
					}
				else{
					win.eText = add( "statictext", undefined, Str, {multiline: 'true', } );
					win.eText.justify = "left";
					win.eText.preferredSize = [400,150];
					}
				win.eText.maximumSize = [450,200];
				win.group = add( "group", undefined, undefined );
				win.group.alignment = ['fill', 'top'];
				win.group.orientation = 'row';
				with(win.group){
					win.group.cBox = add( "checkbox", undefined,  this.localize('Not show Error on this session') );
					win.group.cBox.alignment = ['left', 'center'];
					win.group.cBox.graphics.font = ScriptUI.newFont(win.group.cBox.graphics.font.name, win.group.cBox.graphics.font.style, 10);
					win.group.Exit = add( "button", undefined, 'Exit' );
					win.group.Exit.alignment = ['right', 'top'];
					win.group.Ok = add( "button", undefined, 'Ok' );
					win.group.Ok.alignment = ['right', 'top'];
					}
				}
//			if( this.targetengine )
				win.group.Exit.enabled = false;
//			else
//				win.group.Exit.onClick = function(){
//					this.window.close();
//					LIB.LOG( '', true );
//					exit();
//					}
			win.group.Ok.onClick = function(){
				if( win.group.cBox.value )
					LIB.notShowErrorOnThisSession = true;
				this.window.close();
				}
			win.center();
			win.show();
			}catch(err){ if(!this.notShowErrorOnThisSession) alert(err + '\r' + err.line) }
			},
		systemCheck: function(){
			var support = false;
			var thisApp = this.appName+this.appVersion;
			if( !this.supportApp.length )
				support = true;
			else
				for(var i=0;i<this.supportApp.length;i++)
					if(thisApp == this.supportApp[i]){
						support = true;
						break;
						}
			if( this.supportFS.length )
				for(var i=0;i<this.supportFS.length;i++){
					if(File.fs == this.supportFS[i]){
						support = true;
						break;
						}
					support = false;
					}
			if(support)
				return true;
			if( !this.notShowErrorOnThisSession )
				alert( this.localize('This version of a program is not supported') + ':\r'+this.appName+' '+app.version + '\r\r======================\r'+(this.fullInfo?this.fullInfo():''), this.localize('Error'), true );
			return false;
			},
		//============= ExtendedScript =============================
		isNumber: function( value ){// возвращает true / false, value = Number or String
			var constructorName = this.constructorName(value);
			if( constructorName == 'Number' )
				return true;
			else if( value && constructorName == 'String' )
				return  ( /^\s*?[-+]*?(\d+(\.\d+)*?|(\.\d+)*?)\s*?$/.test(value) );
			return false;
			},
		constructorName: function( value, constructorName ){// возвращает String: имя конструктора ('undefined' | 'null' | constructor.name) , если указан constructorName и он не совпадает с конструктором - возвращает ''
			if( constructorName && constructorName.constructor != String )
				constructorName = undefined;
			if( value == undefined ){
				if( constructorName ) 
					return /undefined/i.test(constructorName) ? 'undefined' : '';
				return 'undefined';
				}
			if( value == null ){
				if( constructorName ) 
					return /null/i.test(constructorName) ? 'null' : '';
				return 'null';
				}
			if( constructorName ) 
				return RegExp(value.constructor.name, 'i').test(constructorName) ? value.constructor.name : '';
			return value.constructor.name;
			},
		getWithPrefix: function( num, targetNum ){ // добавляет к числу префикс, возвращает строку. targetNum - число. под размер которого будет добавлен префикс
			var level = targetNum ? Math.floor(targetNum).toString().length : 1; // округляем в меньшую сторону, переводим в строку и получаем её длинну. По умолчанию level = 1
			var res = num.toString();
			var length = Math.floor(num).toString().length; // округляем в меньшую сторону, переводим в строку и получаем её длинну
			while( length++ < level )
				res = '0' + res;
			return res;
			},
		getMonth: function( index, locale ){
			try{
			locale = locale || this.language;
			if( locale == 'ru' )
				return ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"][index];
			return ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"][index];
			}catch(err){ return "[getMonth error: index = "+index+"]" }
			},
		//============= Messages =============================
		language: ( $.locale == 'ru_RU' ) ? 'ru' : 'en',
		localize: function( string ){
			return string ? ( this.messages[this.language][string] || string ) : '';
			},
		messages: {
			en: {},
			ru: {
				"Processing": 'Обработка',
				"Warning!": 'Внимание!',
				"Continue?": 'Продолжить?',
				"Preferences": 'Настройки',
				"Report": 'Отчет',
				"Error": 'Ошибка',
				"Do not show Error on this session": 'Больше не показывать',
				"This version of a program is not supported": 'Эта версия программы не поддерживается',
				"Error of data": 'Ошибка данных',
				"File not found": 'Файл не найден',
				"Folder not found": 'Папка не найдена',
				"Error writing file": 'Ошибка записи файла',
				"For MacOS: \ryou yourself must create alias in the folder:\r": 'Для MacOS: \rвы самостоятельно должны создать ярлык в папке:\r',
				"Progress": 'Выполнение',
				"Save as": 'Сохранить как',
//				"Error rename file": 'Ошибка переименования файла',
//				"Error deleting file": 'Ошибка удаления файла',
//				"Error load file": 'Ошибка загрузки данных',
				},
			},
		//============= preferences =============================
		checkVersion: function( defaultPrefObject, loadPrefObject, checkOnly ){ // проверяет загруженный объект настроек на соответствие дефолтовому, возвращает проверенный объект
			// checkOnly - Boolean - только проверка на соответствие, возвращает Boolean
			try{
			if( !loadPrefObject || loadPrefObject.constructor != defaultPrefObject.constructor ){
				if( checkOnly )
					return false;
				return defaultPrefObject;
				}
			var result;
			if( defaultPrefObject.constructor == Object )
				for( var i in defaultPrefObject ){
					if( !loadPrefObject.hasOwnProperty(i) || loadPrefObject[i].constructor != defaultPrefObject[i].constructor ){
						if( checkOnly )
							return false;
						 loadPrefObject[i] = defaultPrefObject[i];
						 }
					else if( defaultPrefObject[i].constructor == Object ){
						result = this.checkVersion( defaultPrefObject[i], loadPrefObject[i] );
						if( checkOnly && !result )
							return false;
						}
					}
			if( checkOnly )
				return true ;
			return loadPrefObject;
			}catch(err){ this.alertError(err); return defaultPrefObject }
			},
		// prefs_Init включает подгрузку и сохраниение настроек. Если используется расширение JSON - инициализировать библиотеку следует с флагом log = false, и после подгрузки расширения JSON вызвать prefs_Init
		prefs_Init: function(){
			if( this.savePrefsStatus ) // если подгрузка уже произошла - прерываем
				return;
			this.prefs = { // по умолчанию
				libraryVersion: this.libraryVersion,
				name: this.name,
				version: this.version,
				}
			if( !this.libraryVersion || !this.name || !this.version )
				return;
			var prefs = this.prefRead();
			if( prefs && prefs.constructor == Object && prefs.name && prefs.name == this.name ){
				if( prefs.libraryVersion && prefs.libraryVersion == this.libraryVersion )
					this.prefs = prefs;
				else if( prefs.user ) // извлекаем только пользовательские настройки, которые будут проверяться при несовпадении версий не библиотекой, а самим скриптом
					this.prefs = {libraryVersion: prefs.libraryVersion, name: prefs.name, version: prefs.version, user: prefs.user};
				}
			else
				this.savePrefsStatus = true; // если подгруженные данные не прошли проверку - перезаписываем их при выходе в любом случае
			},
		prefs: {},
		savePrefsStatus: false, // нужно-ли сохранять настройки
		saveScriptPrefs: function(){
			if( this.savePrefsStatus ){
				// обновляем версию настроек
				this.prefs.libraryVersion = this.libraryVersion;
				this.prefs.name = this.name;
				this.prefs.version = this.version;
				
				this.prefSave( this.prefs );
				}
			},
		// если value не указан - возвращает значение по адресу path (путь в объект, разделеный точками) или ''
		// открытая ф-ция, через нее все записывается только в слот user
		userPrefs: function( path, value ){
			return this.workPrefs( 'user.'+path, value );
			},
		// только для внутренних служб библиотеки и расширений
		workPrefs: function( path, value ){
			if( !path )
				return;
			var link = this.prefs;
			// не указан value - возвращаем значение
			if( value == undefined ){
				try{
					try{ path = '["' + path.replace(/"/g,'\\"').replace(/\./g,'"]["') + '"]'; }catch(err){ this.alertError(err) }
					return eval( "link"+path+" == undefined ? '' : link"+path+";" );
					}catch(err){ return '' }
				}
			// иначе - записываем и возвращаем значение
			var keys = path.split('.');
			for( var i = 0; i < keys.length-1; i++ ){
				if( !link[keys[i]] || link[keys[i]].constructor != Object )
					link[keys[i]] = {};
				link = link[keys[i]];
				}
			link[keys[keys.length-1]] = value;
			this.savePrefsStatus = true;
			return value;
			},
		// ЗАКРЫТЫЕ
		prefSave: function( prefObject, file, encode ){
			var str = this.objectToSource( prefObject );
			if( file && file.constructor == File )
				return this.fileWrite( file, str, {encode: encode} );
			return this.fileWrite( this.getPrefFile(), str, {encode: encode} );
			},
		prefRead: function( file, decode ){ // return Object
			var res;
			file = file && file.constructor == File ? file : this.getPrefFile();
			res =  file.exists ? this.fileRead( file, {decode: decode} ) : '';
			res = this.sourceToObject( res );
			if( res.constructor == Error ){
				var mess = 'Error object initialisation from file:\r' + file.fsName;
				mess += '\r\r' +'Error message:\r' + res;
				alert( mess, this.fullName() );
				return {};
				}
			return res;
			},
		getPrefFolder: function(){
			return this.folderCreate( new Folder(this.getWorkingDirectory().absoluteURI + '/' + this.name) );
			},
		workingDirectory: false,
		getWorkingDirectory: function(){
			if( this.workingDirectory && this.constructorName(this.workingDirectory, 'folder') )
				return this.workingDirectory;
			return new Folder( Folder.userData.absoluteURI + '/Adobe/Scripts' );
			},
		getPrefFile: function(){
			var prefFolder = this.getPrefFolder();
			if( !prefFolder )
				return false;
//			return File(this.getPrefFolder().absoluteURI+'/preferrences_v.'+this.adaptForFileName(this.version)+'_'+this.appName+this.appVersion+'.txt');
			return new File(prefFolder.absoluteURI+'/preferrences_v.'+this.version.toString().split('.')[0]+'_'+this.appName+this.appVersion+'.txt'); // файл настроек меняется только на уровне версий скрипта(т.е. подверсии используют один файл настроек)
			},
		resourcesFolder: function(){
			return this.folderCreate( new Folder(this.getPrefFolder().absoluteURI + '/resources') );
			},
		objectToSource: function( object ){
//			return '';
			if( this.JSON )
				return this.JSON.objectToSource( object );
			if( object == undefined || object == null || !Object.isValid(object) || object instanceof Array )
				return '{}';
//			return encodeURI(uneval(object));
			return uneval( object );
			},
		sourceToObject: function( string ){
			if( /^\s*?$/.test(string) )
				return {};
			if( this.JSON )
				return this.JSON.sourceToObject( string );
			if( !string )
				return {};
//			var source = decodeURI(string).replace(/[\n\r]/g,'\\n').replace(/[\t]/g,'\\t');
			try{
			var res = eval( '('+ string +')' );
			return res && Object.isValid(res) && res.constructor == Object ? res : {};
			}catch(err){
				return err;
				
				this.alertError( err );
				return {};
				}
			},
		//============= file system =============================
		folderCreate: function( folder ){ // folder = Folder or String, return Folder / false
			if( !folder )
				return false;
			if( this.constructorName(folder, 'folder') ){
				}
			else if( this.constructorName(folder, 'string') )
				folder = new Folder( folder );
			else return false;
			if( !folder.exists ){
				// функция взята из: BobsScriptLibrary
				var oFolder = new Folder( folder.absoluteURI ); // make a new folder object (copy) to play with
				var stk = new Array();
				while( !oFolder.exists ){ // we know this first one will not exist
					stk.push( oFolder ); // so push this folder onto the stack
					oFolder = new Folder( oFolder.path ); // and then check to see if the parent folder exists, if so, stop this loop
					}
				stk2 = new Array(); // this is to remove created folders if one of the subsequent folder creations fails - leave nothing behind
				while ( stk.length > 0 ){ // while there's still stuff in the stack
					oFolder = stk.pop(); // pop off the last one, create it, push it onto the error recovery stack if it works, if it doesn't unwind what we've done
					if( oFolder.create() )
						stk2.push( oFolder );
					else{
						while ( stk2.length > 0 )
							stk2.pop.remove();
						this.alertError( err );
						return false;
						} 
					}
				}
			return folder;
			},
		folderClear: function( folder ){ // return false / true
			var flag = true;
			try{
			var files = folder.getFiles();
			if( files.length )
				for( var i = files.length-1; i > -1; i-- ){
					if( files[i] instanceof Folder )
						flag = this.folderClear( files[i] );
					files[i].remove();
					}
			}catch(err){ flag = false; }
			finally{ return flag }
			},
		fileRead: function( file, opts ){ // opts = { decode: Bool }
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			if(!file.exists){
				if( !this.notShowErrorOnThisSession ) 
					alert( 'fileRead:\n' + this.localize('File not found') + ':\n\n'+file.fsName, this.localize('Error'), true );
				return false;
				}
			var result = false;
			try{
			file.open( 'r' );
			var result = file.read();
			result = opts.decode ? decodeURI( result ) : result;
			}catch( err ){ 
				this.alertError( err ); 
				result = false; 
				}
			finally{
			file.close();
			}
			return result;
			},
		fileWrite: function( file, string, opts ){ // opts = { encode: Bool, encoding: String }
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			var result = false;
			var Err = '';
			string = opts.encode ? encodeURI( string ) : string;
			try{
			if( !file.parent.exists )
				throw ( this.localize('Folder not found') + ": " + file.parent.fsName );
			file.open("w");
			if( opts.encoding && opts.encoding.constructor == String )
				file.encoding = opts.encoding;
			result = file.write( new String(string) );
			if( File.fs == 'Macintosh' )
				result = true;// в MacOS проверить запись не получается - при положит. записи тоже возвращает false,  сравнение записываемой строки и рез-т чтения после записи тоже возвр. false
			}catch( err ){ 
				Err = err;
				result = false; 
				}
			finally{
				file.close();
				if( !result )
					if( !this.notShowErrorOnThisSession ) 
						alert( this.localize('Error writing file') + "!\n\nFile:\n" + file.fsName + (Err ? '\r\rSystem message:\r' + Err +'\rline: '+Err.line : ''));
				}
			return result;
			},
		fileWriteLine: function( file, string, opts ){
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			var result = false;
			var Err = '';
			string =  opts.encode ? encodeURI( string ) : string;
			try{
			if( !file.parent.exists )
				throw ( this.localize('Folder not found') + ": " + file.parent.fsName );
			file.open('a');
			if( opts.encoding && opts.encoding.constructor == String )
				file.encoding = opts.encoding;
			result = file.writeln( new String(string) );
			if( File.fs == 'Macintosh' )
				result = true;// в MacOS проверить запись не получается - при положит. записи тоже возвращает false,  сравнение записываемой строки и рез-т чтения после записи тоже возвр. false
			}catch( err ){ 
				Err = err;
				result = false; 
				}
			finally{
				file.close();
				if( !result )
					if( !this.notShowErrorOnThisSession ) 
						alert( this.localize('Error writing file') + "!\n\nFile:\n" + file.fsName + (Err ? '\r\rSystem message:\r' + Err +'\rline: '+Err.line : ''));
				}
			return result;
			},
		adaptForFileName: function(str){
			return str.toString().replace(/[ \\\/:*?"<>|]/g, '_');
			},
		adaptFsNameForSave: function(fsName){
			return fsName.replace(/\\/g, '/').replace(/\'/g, '\\\'');
			},
		getDisplayName: function(fsObject){
			return fsObject.fsName.split(/[\\\/]/).reverse()[0];
			},
		getNameOnly: function(fsObject){
			return fsObject instanceof Folder ? this.getDisplayName( fsObject ) : this.getDisplayName( fsObject ).split('.').slice(0,-1).join('.');
			},
		getExpansion: function(fsObject){
			return fsObject instanceof Folder ? '' : this.getDisplayName( fsObject ).split('.').reverse()[0] ;
			},
		getFileAlias: function(folder, file, create){
			try{
			var aliases = folder.getFiles(function(file){return file.alias});
			var fileLink = file.absoluteURI;
			for(var i = 0; i < aliases.length; i++)
				if(aliases[i].resolve().absoluteURI == fileLink)
					return aliases[i];
			if(create){
				if(!folder.exists)
					folder.create();
				if(File.fs == 'Macintosh'){
					if( !this.notShowErrorOnThisSession ) 
						alert( this.localize('For MacOS: \ryou yourself must create alias in the folder:\r') + folder.fsName);
					return false;
					}
				var alias = new File(folder.absoluteURI + '/'  + this.getDisplayName(file));
				alias.createAlias(file);
				return alias;
				}
			return false;
			}catch(err){this.alertError(err)};
			},
		moveFile: function( FILE, FOLDER ){
			if( !FOLDER.exists )
				FOLDER.create();
			if( FILE.copy(FOLDER.absoluteURI +"/" + FILE.name) ){
				FILE.remove();
				return true;
				}
			},
		//============= application data =============================
		appName: app.name.replace('Adobe ',''),
		getAppName: function( str ){ var name = app.name.split(' ').reverse()[0].toLowerCase(); return arguments.length ? (RegExp(name,'ig').test(arguments[0])?name:false) : name; },// если указан str - возвращает результат поиска в строке имени программы
		appVersion: parseFloat( app.version ),
		appVersionCS: function(){
			switch( this.appName ){
				case 'InDesign':
				return this.appVersion - 2;
				case 'Photoshop':
				return this.appVersion - 7;
				case 'Illustrator':
				return this.appVersion - 10;
				default:
				return 0;
				}
			},
		getStartupFolder: function(){
			var folder = new Folder((app.filePath || app.path) + ((this.appName == 'InDesign')?'/Scripts':'') + '/Startup Scripts');
			if(!folder.exists)
				folder.create();
			return folder;
			},
		getInDesignIcon: function( iconCataloquePath ){
			if( iconCataloquePath && this.getAppName('indesign') && this.appVersionCS() >= 5 ){
				var path = app.filePath + '/Plug-Ins/' + iconCataloquePath;
				if( new File(path).exists )
					return ScriptUI.newImage( path );
				return false;
				}
			},
		//============= scriptUI =============================
		images: [],
		writeImage: function(codeStr, name){
			var folder = this.resourcesFolder();
			if(!folder.exists)
				folder.create();
			var pngFile = new File(folder.absoluteURI + '/' + name + '.png');
			if(!pngFile.exists){
				pngFile.encoding = "BINARY";
				if(!this.fileWrite(pngFile, codeStr)){
					this.images[name] = false;
					return false;
					}
				}
			this.images[name] = ScriptUI.newImage(pngFile.absoluteURI);
			return this.images[name];
			},
		getUiObjectIndex: function(uiObject){
			try{
			for(var i = 0; i < uiObject.parent.children.length; i++)
				if(uiObject.parent.children[i] == uiObject)
					return i;
			}catch(err){this.alertError(err)};
			},
		resizeWindow: function( window, sizeIndex, value ){//sizeIndex: 0 - hor, 1 - vert
			try{
			var size = [0,0];
			size[sizeIndex] = value;
			var location = [window.location[0], window.location[1]];
			var bounds = [window.bounds[0], window.bounds[1], window.bounds[2], window.bounds[3]];
			window.location = location;
			window.bounds = [bounds[0], bounds[1], bounds[2]+size[0], bounds[3]+size[1]];
			window.location = location;
			}catch(err){ this.alertError( err ); }
			},
		confirm: function( tittle, message, multiline ){ // return undefined / false / true
			var result = undefined;
			var win = new Window( 'dialog', tittle );
			win.alignChildren = 'right';
			win.margins = 5;
			win.spacing = 5;
			with(win){
				if( message )
					win.Text = add('statictext', undefined, message, {multiline:multiline});
				win.Grp = add('group');
				win.Grp.orientation = 'row';
				win.Grp.spacing = 5;
				with(win.Grp){
					win.Grp.Cancel = add('button', undefined, 'Cancel');
					win.Grp.no = add('button', undefined, 'No');
					win.Grp.ok = add('button', undefined, 'OK');
					}
				}
			win.Grp.Cancel.onClick = function(){
				this.window.close();
				}
			win.Grp.no.onClick = function(){
				result = false;
				this.window.close();
				}
			win.Grp.ok.onClick = function(){
				result = true;
				this.window.close();
				}
			win.defaultElement = win.Grp.ok;
			win.center();
			win.show();
			return result;
			},
		getReportWindow: function( reportText, tittle, reportName, width ){//ОКНО ВЫВОДА РЕЗУЛЬТАТОВ
			tittle = tittle || '';
			width = width || 400;
			var _height = new String( reportText ).split('\r').length;
			var resizeable = this.hasOwnProperty('addDynamicObject');
			if( _height == 1 ) _height = 22;
			else _height = ( _height < 20 ) ? 15*_height : 300;
			var winReport = new Window( 'dialog', tittle, undefined, {resizeable: resizeable} );
			winReport.alignChildren = 'left';
			winReport.margins = 5;
			winReport.spacing = 10;
			with(winReport){
				if( reportName ){
					winReport.Name = add('statictext', undefined, reportName, {multiline:true});
					winReport.Name.preferredSize = [ width, winReport.Name.preferredSize[1] ];
					}
				winReport.Text = add('edittext', undefined, reportText, {multiline:true, readonly: ( File.fs == 'Windows' )});
				winReport.Text.alignment = ["fill", "fill"];
				winReport.Text.preferredSize = [ width, _height ];
				
				winReport.ok = add('button', undefined, 'OK');
				winReport.ok.alignment = 'center';
				};
			winReport.ok.onClick = function(){
				this.window.close();
				}
			//====================== RESIZE
			if( resizeable ){
				script.addDynamicObject( { obj: winReport.Text, moveCoefs: false, resizeCoefs: [1,1], isSeparator: false, windowKeyRestore: script.name+'_ReportWindow' } );
				script.addDynamicObject( { obj: winReport.ok, moveCoefs: ['center',1], resizeCoefs: false, isSeparator: false } );
				if( winReport.Name )
					script.addDynamicObject( { obj: winReport.Name, moveCoefs: false, resizeCoefs: [1,0], isSeparator: false } );
				}
			else{
				winReport.Text.minimumSize = [ width, _height ];
				winReport.ok.minimumSize = winReport.ok.maximumSize = [100, 22 ];
				
				winReport.onResizing = function() {this.layout.resize()}
				winReport.onShow = function(){
					this.layout.layout();
					this.minimumSize = this.preferredSize;
					}
				}

			winReport.center();
			winReport.show();
			},
		getProgressBar: function( container, maxValue, size, location, reverse ){//возвращает progressbar с ф-цией setValue( [num] )
			size = size || [200, 8];
			location = location || [0,0];
			if( File.fs == '_Macintosh' ){ // отключено
				var pBar = container.add('group', [location[0], location[1], location[0]+size[0], location[1]+size[1]]);
				pBar.visible = false;
				pBar.graphics.backgroundColor =
				pBar.graphics.disabledBackgroundColor = // в окне, у которого нет фокуса - ничего не обновляется, disabledBackgroundColor не помогает
					pBar.graphics.newBrush(pBar.graphics.BrushType.SOLID_COLOR, [0/255, 0/255, 255/255, 1]);
				pBar.step = pBar.size[0]/maxValue;
				pBar.value = 0;
				pBar.setValue = function( num ){
					num = num || 1;
					if( !this.value || this.value >= maxValue ){
						this.size = [0, this.size[1]];
						this.visible = true;
						this.value = 0;
						}
					this.value += num;
					this.size = [this.step*this.value, this.size[1]];
					}
				return pBar;
				}
			if( reverse ){
				var pBar = container.add('progressbar', [location[0], location[1], location[0]+size[0], location[1]+size[1]], maxValue, maxValue);
				pBar.setValue = function( num ){
					num = num || 1;
					if( this.value >= maxValue ) this.value = maxValue;
					this.value -= num;
					};
				return pBar;
				}
			var pBar = container.add('progressbar', [location[0], location[1], location[0]+size[0], location[1]+size[1]], 0, maxValue);
			pBar.setValue = function( num ){
				num = num || 1;
				if( (this.value + num) > maxValue ){
					num = (maxValue - this.value) || 1;
					this.value = 0;
					}
				this.value += num;
				};
			return pBar;
			},
		getProgressWindow: function( maxValue, title, reverse ){//return palette{ setValue: function( [num] ) }
			var LIB = this;
			title = title || this.localize('Progress');
			var myProgressPanel = new Window('palette', title);
			myProgressPanel.progressBar = this.getProgressBar( myProgressPanel, maxValue, undefined, undefined, reverse );
			myProgressPanel.setValue = function( num ){
				this.progressBar.setValue( num );
				}
			myProgressPanel.addProgressBar = function( maxValue, reverse ){
				var pBar = LIB.getProgressBar( this, maxValue, undefined, undefined, reverse ); // with 
				pBar.removeBar = function(){
					var win = this.window;
					win.remove( this );
					win.layout.layout( true );
					}
				this.layout.layout( true );
				return pBar;// return  ProgressBar with functs setValue(num) and removeBar()
				}
			return myProgressPanel;
			},
		addGroupListener: function( prefs ){ // prefs = {objs: Array of UIObjects, listener: function( event ), onChangingMode: Bool }
			if( !prefs || !prefs.objs || !prefs.objs || !prefs.listener || prefs.listener.constructor != Function )
				return;
			if( prefs.objs.constructor != Array )
				prefs.objs = [prefs.objs];
			for( var i = 0; i <prefs.objs.length; i++ ){
				if( prefs.objs[i].hasOwnProperty('margins') ){// обработчики для содержимого контейнеров
					if( prefs.onChangingMode )
						prefs.objs[i].addEventListener( 'changing', prefs.listener );
					else{
						prefs.objs[i].addEventListener( 'click', prefs.listener );
						prefs.objs[i].addEventListener( 'change', prefs.listener );
						}
					continue;
					}
				switch( prefs.objs[i].type ){
					case "dropdownlist":
					case "listbox":
					case "treeview":
					case "edittext":
					case "scrollbar":
					case "slider":
						if( prefs.onChangingMode )
							prefs.objs[i].addEventListener( 'changing', prefs.listener );
						else
							prefs.objs[i].addEventListener( 'change', prefs.listener );
					break;
					case "checkbox":
					case "radiobutton":
					case "button":
					case "iconbutton":
						prefs.objs[i].addEventListener( 'click', prefs.listener );
					}
				}
			},
		}
		return scriptLIB;
		};
	}
function extension_scriptInfo( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'scriptInfo';
	var version = 1.2;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	script.messages.en.info = 'Info';
	script.messages.en.script = 'Script';
	script.messages.en.help = 'Help';
	script.messages.en.system = 'System';
	script.messages.ru.info = 'Информация';
	script.messages.ru.script = 'Скрипт';
	script.messages.ru.help = 'Помощь';
	script.messages.ru.system = 'Система';
	script.supportInfo = function(){
		try{
		var arr_cs = [];
		var arr_supApps = [];
		if( this.supportApp.length ){
			var cs = {};
			var supApps = {};
			for(var i = 0;i<this.supportApp.length; i++){
				var res = /(\D+)(\d+)/.exec( this.supportApp[i] );
				if( !res ) continue;
				supApps[res[1]] = true;
				switch( res[1] ){
					case 'InDesign':
					cs['CS'+(+res[2]-2)] = true;
					break;
					case 'Photoshop':
					cs['CS'+(+res[2]-7)] = true;
					break;
					case 'Illustrator':
					cs['CS'+(+res[2]-10)] = true;
					}
				}
			
			for( var i in cs )
				arr_cs.push( i );
			for( var i in supApps )
				arr_supApps.push( i );
			}
		else{
			arr_supApps.push('InDesign','Photoshop','Illustrator');
			arr_cs.push('CS3','CS4','CS5');
			}
		var supportFS = this.supportFS.length ? this.supportApp.length : ['Windows','Macintosh'];
		var str = arr_supApps.join('/') + ' ' + arr_cs.join('/') + ' ' + supportFS.join('/');
		return str;
		}catch(err){this.alertError(err)}
		},
	script.fullInfo = function(){
		return this.fullName()+'\r'+
			'for '+this.supportInfo()+'\r\r'+
			'script of '+this.autor+', '+this.release+'\r'+
			this.mail+'\r'+
			this.sites.join('\r');
		},
	script.getWinInfo = function( addInfo, help ){ // addInfo - additional information about the script
		try{
		addInfo = addInfo ? '\r\r'+addInfo : '';
		help = help || '';
		var thisSite = ( !this.sites || !(this.sites instanceof Array) || this.sites.length == 0 ) ? false : this.sites[0];
		var addScriptInfo = function( container ){
			var item;
			with(container){
				item = add('statictext', undefined, container.window.core.fullInfo() + addInfo , {multiline: true});
				
				var buts = add('group');
				buts.orientation = 'row';
				buts.alignment = 'right';
				buts.margins = [0,10,0,10];
				if( thisSite ){
					var site = buts.add('button', undefined, thisSite);
					site.onClick = function(){
						this.window.core.connectToSite();
						this.window.close();
						}
					}
				var news = buts.add('button', undefined, "News");
				news.onClick = function(){
					this.window.core.newsService();
					this.window.close();
					}
				}
			}
		var addHelpInfo = function( container ){
			var item = container.add('statictext', undefined, help, {multiline: true, scrolling: true });
			item.preferredSize = [350,300];
			}
		var addSystemInfo = function( container ){
			var item = container.add('statictext', undefined, container.window.core.getSystemInfo(), {multiline: true});
			}
		var winInfo = new Window( 'dialog', this.localize('info') );
		winInfo.core = this;
		winInfo.preferredSize = [400,10];
		winInfo.alignChildren = 'fill';
		winInfo.margins = 5;
		winInfo.spacing = 5;
		if(this.appVersionCS() > 3){//CS4 и старше
			with(winInfo){
				winInfo.tPnl = add('tabbedpanel');
				with(winInfo.tPnl){
					winInfo.tPnl.script = add( 'tab', undefined, this.localize('script') );
					winInfo.tPnl.script.orientation = 'column';
					winInfo.tPnl.script.alignChildren = 'fill';
					addScriptInfo( winInfo.tPnl.script );
					
					if( help ){
						winInfo.tPnl.help = add( 'tab', undefined, this.localize('help') );
						winInfo.tPnl.help.orientation = 'column';
						winInfo.tPnl.help.alignChildren = 'fill';
						addHelpInfo( winInfo.tPnl.help );
						}
					
					winInfo.tPnl.system = add( 'tab', undefined, this.localize('system') );
					winInfo.tPnl.system.orientation = 'column';
					winInfo.tPnl.system.alignChildren = 'fill';
					addSystemInfo( winInfo.tPnl.system );
					}
				}
			}
		else{//CS3
			addScriptInfo( winInfo );
			winInfo.tPnl = winInfo.add( 'panel', undefined, this.localize('system') );
			winInfo.tPnl.alignChildren = 'fill';
			addHelpInfo( winInfo.tPnl );
			addSystemInfo( winInfo.tPnl );
			}
		winInfo.ok = winInfo.add('button', undefined, "OK");
		winInfo.ok.alignment = 'center';
		winInfo.ok.onClick = function(){
			this.window.close();
			}
		winInfo.center();
		winInfo.show();
		}catch(err){this.alertError(err)};
		},
	script.getSystemInfo = function(){
		var str = '';
		try{
		str+=$.os+'\r';
		str+=this.appName+' '+this.appVersion+'\r';
		str+='Language: '+$.locale+'\r';
		str+='ScriptUI: '+ScriptUI.version+'\r';
		str+= '\r' + 'scriptLibrary: '+this.libraryVersion+'\r';
		if( this.extensions.toSource() != '({})' ){
			str += 'scriptExtensions:\r';
			for( var name in this.extensions )
				str += '   ' + name + ': ' + this.extensions[name].version + (this.extensions[name].description ? ' ('+this.extensions[name].description+')':'') + '\r';
			}
		return str;
		}catch(err){ return str }
		},
	script.connectToSite = function(){
		if( !this.sites || !(this.sites instanceof Array) || this.sites.length == 0 )
			return;
		var thisSite = this.sites[0];
		var urlFile = File(Folder.temp.absoluteURI + '/'+this.adaptForFileName(thisSite)+'.url');
		if(!urlFile.exists)
			this.fileWrite( urlFile, '[DEFAULT]\rBASEURL=http://'+thisSite+'/\r[InternetShortcut]\rURL=http://'+thisSite+'/' );
		try{
			urlFile.execute();
			} catch(err) {this.alertError(err)}
		},
	script.newsService = function(){
		try{
		if( this.appName == 'Illustrator' ){
			alert( "Error.\rAdobe Illustrator don't support TCP-connection through Socket object." )
			return;
			}
		var address = "scriptuibuilder.com";
		var path = 'news.html';
		var socket = new Socket;
		socket.timeout = 120;
		if ( !socket.open( address + ':80' ) ){
			alert("Error of connecting with scriptuibuilder.com");
			return;
			}
		var request = 
			"GET /" + path + " HTTP/1.1\n" +
			"Host: " + address + "\n" +
			"User-Agent: "+this.fullName()+"("+this.appName+this.appVersion+")\n" +
			"Accept: text/plain\n" + 
			"Accept-Encoding:\n" +
			"Connection: keep-alive\n" +
			"Accept-Language: *\n" + 
			"Accept-Charset: utf-8\n\n";
		socket.write(request);
		var data = '';
		while(!socket.eof)
			data += socket.read();
		socket.close();
		data = data.split('\n');//переводим строку в массив
		var tagData = this.getTagArray( data, 'news' );
		if( !tagData ){
			alert( this.localize('Error of data') );
			return;
			}
		this.getReportWindow( tagData.join('\r'), "News Service scriptuibuilder.com" );
		}catch(err){this.alertError(err); };
		}
	script.getTagArray = function( array, tag ){//возвращает массив между тэгами <tag> и </tag>, для ф-ции newsService, пропускает строки, начинающиеся с //
		try{
		var index = {start: -1, end: -1};
		var tag = {open: '<'+tag+'>', close: '</'+tag+'>'};
		for (var i = 0; i < array.length; i++){
			if ( array[i] == tag.open )
				index.start = i + 1;
			if ( array[i] == tag.close ){
				index.end = i;
				break;
				}
			}
		if( index.start < 0 || index.end < 0 )
			return '';
		var res = array.slice(index.start, index.end);
		for (var i = res.length; i >= 0; i--)
			if( /^\/\//.test(res[i]) )
				res.splice( i, 1 );
		return res;
		}catch(err){this.alertError(err);};
		}
	}
function extension_contextMenu( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'contextMenu';
	var version = 1.31;
	var script = scriptLibrary;
	if( script.appVersionCS() < 4 )
			return alert( 'This version of program no support: '+script.appName+' CS'+ script.appVersionCS(), 'extension_contextMenu', true );
	script.extensions[name] = {version: version};
	
	script.alwaysActiveContextMenuItem = function(){ return true };
	script.deactivateContextMenuItem = function(){ return false };
	script.separatorMenuItem = {}; // separator with line
	//=================================
	script.addContextMenu = function( opts ){
		// opts = { target: uiObject, menuItems: Array of menuItems, palette: bool (only for targetengine 'session' and Windows), preAction: function(EVENT, optionsObject){return false/true} }, optionsObject = {title:"", titleImage: ScriptUIImage}
		// menuItems = { name: "", action: function( EVENT ), activation: function(EVENT){return true/false} or true, notCloseMenu: bool, image: ScriptUIImage }
		if( !opts )
			return;
		var uiObject = opts.target;
		var items = opts.menuItems;
		var paletteType = ( (opts.palette || this.targetengine) && File.fs == 'Windows');
		var preAction = opts.preAction && opts.preAction.constructor == Function ? opts.preAction : function(){return true};
		if( !items || items.constructor != Array )
			return;
		var names = [];
		var activation;
		var imagesStatus; // присутствует ли графика
		var line = "____________"; // separator
		for( var i = 0; i < items.length; i++ )
			if (items[i].name && line.length < items[i].name.length ) line = items[i].name;
		line = line.replace(/./g,'_');
		var elements = { "":{ activation: script.deactivateContextMenuItem }};
		elements[line] = { activation: script.deactivateContextMenuItem };
		for( var i = 0; i < items.length; i++ ){
			if( items[i].constructor != Object ) continue;
			if( items[i] == script.separatorMenuItem ){
				names.push( line );
				continue;
				}
			if( !items[i].name ){
				names.push( "" );
				continue;
				}
			names.push( items[i].name );
			if( !items[i].action || items[i].action.constructor != Function ){
				elements[items[i].name] = { activation: script.deactivateContextMenuItem };
				continue;
				}
			if( !items[i].activation )
				activation = script.deactivateContextMenuItem;
			else if( items[i].activation===true )
				activation = script.alwaysActiveContextMenuItem;
			else if( items[i].activation.constructor == Function )
				activation =  items[i].activation;
			else
				activation = script.deactivateContextMenuItem;
			elements[items[i].name] = {
				action: items[i].action,
				activation: activation,
				notCloseMenu: items[i].notCloseMenu ? true : false
				}
			if( items[i].image && items[i].image.constructor == ScriptUIImage ){
				elements[items[i].name].image = items[i].image;
				imagesStatus = true;
				}
			}
		if( !paletteType ){
			elements[line] = { activation: script.deactivateContextMenuItem };
			elements["Close menu"] = { action: function(){}, activation: script.alwaysActiveContextMenuItem };
/*			if( imagesStatus ){
				var icon = script.getInDesignIcon( 'Workgroup/(Workgroup UI Resources)/idrc_PNGA/4518.idrc' );
				if( icon )
					elements.Close.image = icon;
				}*/
			names = names.concat( [line,"Close menu"] );
			}
		uiObject.addEventListener( "mousedown", contextMenu );
		
		function contextMenu(e){
			if( e.button != 2 ) // only right button
				return;
			var options = {title:""};
			if( !preAction(e, options) )
				return;
			var EVENT = {};
			for( var i in e )
				EVENT[i] = e[i];
			e.preventDefault();
			e.target.active = true;// переводим фокус на цель
			var CM = new Window (paletteType?"palette":"dialog", undefined, undefined, {borderless: (File.fs=='Windows')});
			if( paletteType ){
				CM.addEventListener( "blur", function(){CM.close(); delete CM} );
				}
			CM.margins = 0;
			CM.opacity = 0.8;
			
			var thisNames = options.title ? [options.title,""].concat( names ) : names;
			var STR = options.title && (line.length < options.title.length) ? options.title.replace(/./g,'_') : line;
			var width = CM.graphics.measureString(STR)[0]+(File.fs=='Windows'?10:50);
			var itemHeight = 18;
			if( imagesStatus ){
				CM.lBox = CM.add('listbox', undefined, undefined, {numberOfColumns: 2, showHeaders: false, columnWidths: [25, width]});
				var item;
				for( var i = 0; i < thisNames.length; i++ ){
					item = CM.lBox.add('item', '');
					if( elements[thisNames[i]] && elements[thisNames[i]].image ){
						item.image = elements[thisNames[i]].image;
//						if( item.image.size[1] > itemHeight )
//							itemHeight = item.image.size[1];
						}
					item.subItems[0].text = thisNames[i];
					try{ CM.lBox.items[i].enabled = elements[thisNames[i]] && elements[thisNames[i]].activation(EVENT) ? true : false }catch(err){ script.alertError(err); CM.lBox.items[i].enabled = false }
					}
				width += 30;
				}
			else{
				CM.lBox = CM.add('listbox', undefined, undefined, {items: thisNames});
				for( var i = 0; i < thisNames.length; i++ )
					try{ CM.lBox.items[i].enabled = elements[thisNames[i]] && elements[thisNames[i]].activation(EVENT) ? true : false }catch(err){ script.alertError(err); CM.lBox.items[i].enabled = false }
				}
			CM.lBox.itemSize = [undefined, itemHeight];
			CM.lBox.preferredSize = [ width, thisNames.length*itemHeight+10+(File.fs=='Windows'?0:20)];
			CM.lBox.onChange = function(){
				var action = imagesStatus ? elements[this.selection.subItems[0].text].action : elements[this.selection.text].action;
				var element = imagesStatus ? elements[this.selection.subItems[0].text] : elements[this.selection];
				if( !element.notCloseMenu ){
					this.window.close();
					if( paletteType )
						delete CM;
					}
				else
					this.selection = null;
				try{ action(EVENT) }catch(err){script.alertError(err)}
				}
			if( script.addMouseMove ){
				script.addMouseMove( { target: CM.lBox, direction: [true, true],  withFunct: function(move){CM.location = [CM.location[0]+move[0], CM.location[1]+move[1]]}, notMoveTarget: true } );
				}
			
			CM.location = [
				$.screens[0].right < e.screenX+CM.lBox.preferredSize[0] ? e.screenX - CM.lBox.preferredSize[0] : e.screenX, 
				$.screens[0].bottom < e.screenY+CM.lBox.preferredSize[1] ? e.screenY - CM.lBox.preferredSize[1] : e.screenY, 
				];
			CM.active = true;
			CM.show();
			}
		}
	}



}
}
scriptPalette_AlexDenScripts();
